#
# spec file for package xerces-j2
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           xerces-j2
%define name		xerces-j2
%define version	2.8.1
%define cvs_version	2_8_1
%define release		3jpp
%define section		free
Version:        2.8.1
Release:        9.1
Summary:        Java XML parser
License:        Apache-2.0
Group:          Development/Libraries/Java
Url:            http://xml.apache.org/xerces2-j/
Source0:        Xerces-J-src.%{version}.tar.bz2
Source1:        %{name}-version.sh
Source2:        %{name}-constants.sh
Source3:        Xerces-J-tools.%{version}.tar.bz2
Patch1:         java150_build.patch
Patch2:         %{name}-%{version}_new_unsupported_dom_methods.patch
#PATCH-FIX-UPSTREAM bnc#530717
#http://svn.apache.org/viewvc?view=rev&revision=787352
Patch3:         xerces-j2-parsing.patch
Patch4:         xerces-j2-arrays-doubling.patch
Patch5:         xerces-j2-scan-pseudo-attribute.patch
#PATCH-FIX-UPSTREAM bsc#1047536 bsc#879138  Bug with pattern restriction on long strings
Patch6:         xerces-regularexpression-backport.patch
Provides:       jaxp_parser_impl
PreReq:         update-alternatives /bin/ln
# some build requirements removed to enable jpackage bootstrap. this is
# the first package built, and we use the libraries in the tools subdir
# for it.
BuildRequires:  java-1_5_0-gcj-compat-devel
#!BuildIgnore:  java-1_6_0-openjdk java-1_6_0-openjdk-devel
#!BuildIgnore:  antlr antlr-java
BuildRequires:  javapackages-tools
BuildRequires:  unzip
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Welcome to the future! Xerces2 is the next generation of high
performance, fully compliant XML parsers in the Apache Xerces family.
This new version of Xerces introduces the Xerces Native Interface
(XNI), a complete framework for building parser components and
configurations that is extremely modular and easy to program.

The Apache Xerces2 parser is the reference implementation of XNI but
other parser components, configurations, and parsers can be written
using the Xerces Native Interface. For complete design and
implementation documents, refer to the XNI Manual.

Xerces 2 is a fully conforming XML Schema processor. For more
information, refer to the XML Schema page.

Xerces 2 also provides a partial implementation of Document Object
Model Level 3 Core, Load and Save and Abstract Schemas [deprecated]
Working Drafts. For more information, refer to the DOM Level 3
Implementation page.

%package        demo
Summary:        Demonstration and sample files for xerces-j2
Group:          Development/Libraries/Java
Requires:       %{name} = %{version}

%description    demo
Welcome to the future! Xerces2 is the next generation of high
performance, fully compliant XML parsers in the Apache Xerces family.
This new version of Xerces introduces the Xerces Native Interface
(XNI), a complete framework for building parser components and
configurations that is extremely modular and easy to program.

The Apache Xerces2 parser is the reference implementation of XNI but
other parser components, configurations, and parsers can be written
using the Xerces Native Interface. For complete design and
implementation documents, refer to the XNI Manual.

Xerces 2 is a fully conforming XML Schema processor. For more
information, refer to the XML Schema page.

Xerces 2 also provides a partial implementation of Document Object
Model Level 3 Core, Load and Save and Abstract Schemas [deprecated]
Working Drafts. For more information, refer to the DOM Level 3
Implementation page.

This package contains demonstration and sample files for Xerces2.



%package        scripts
Summary:        Additional utility scripts for xerces-j2
Group:          Development/Libraries/Java
Requires:       %{name} = %{version}
Requires:       javapackages-tools

%description    scripts
Welcome to the future! Xerces2 is the next generation of high
performance, fully compliant XML parsers in the Apache Xerces family.
This new version of Xerces introduces the Xerces Native Interface
(XNI), a complete framework for building parser components and
configurations that is extremely modular and easy to program.

The Apache Xerces2 parser is the reference implementation of XNI but
other parser components, configurations, and parsers can be written
using the Xerces Native Interface. For complete design and
implementation documents, refer to the XNI Manual.

Xerces 2 is a fully conforming XML Schema processor. For more
information, refer to the XML Schema page.

Xerces 2 also provides a partial implementation of Document Object
Model Level 3 Core, Load and Save and Abstract Schemas [deprecated]
Working Drafts. For more information, refer to the DOM Level 3
Implementation page.

This package contains additional utility scripts for Xerces2.



%package        xml-resolver
Summary:        Resolver subproject of xml-commons
Group:          Development/Libraries/Java
Requires:       javapackages-tools
Provides:       xml-commons-resolver
PreReq:         update-alternatives

%description    xml-resolver 
xml-commons is focused on common code and guidelines for xml projects.
The first focus will be to organize and have common packaging for the
various externally-defined standards code relating to XML - things like
the DOM, SAX, and JAXP interfaces.

This package contains the resolver subproject of xml-commons.



%package        xml-apis
Summary:        APIs subproject of xml-commons
Group:          Development/Libraries/Java
Requires:       javapackages-tools
Provides:       xml-commons-apis
PreReq:         update-alternatives

%description    xml-apis 
xml-commons is focused on common code and guidelines for xml projects.
Its first focus will be to organize and have common packaging for the
various externally-defined standards code relating to XML - things like
the DOM, SAX, and JAXP interfaces. As the xml-commons community forms,
we also hope to serve as a holding area for other common xml-related
utilities and code, and to help promulgate common packaging, testing,
documentation, and other guidelines across all xml.apache.org
subprojects.

This package contains the APIs subproject of xml-commons.



%prep
%setup -q -n xerces-%{cvs_version}
%setup -q -T -a 3 -D -n xerces-%{cvs_version}
%setup -T -D -n xerces-%{cvs_version}
%patch1 -p1
%patch2 -p1
%patch3 -p1 -b .parsing
%patch4
%patch5
%patch6 -p1

%build
## this uses the ant.jar provided by the xerces packages. Tough luck,
# jpackage bootstrap has to start somewhere. It is not installed,
# though.
export JAVA_HOME=%{_libdir}/jvm/java-1.5.0-gcj
export GC_MAXIMUM_HEAP_SIZE="134217728"
export CLASSPATH=$CLASSPATH:`build-classpath antlr-bootstrap`
sh build.sh jars

#ant tests test

%install
# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/xercesImpl.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
cp -p build/resolver.jar   $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-xml-resolver.jar
cp -p build/xml-apis.jar   $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-xml-apis.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)
# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}-version
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/%{name}-constants
# demo
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -p build/xercesSamples.jar \
  $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-samples.jar
cp -pr data $RPM_BUILD_ROOT%{_datadir}/%{name}
# jaxp_parser_impl ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/jaxp_parser_impl.jar
# xml-apis ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/xml-commons-apis.jar
# xml-resolver ghost symlink
ln -s %{_sysconfdir}/alternatives \
  $RPM_BUILD_ROOT%{_javadir}/xml-commons-resolver.jar

%clean
rm -rf $RPM_BUILD_ROOT

%post
/usr/sbin/update-alternatives --install %{_javadir}/jaxp_parser_impl.jar jaxp_parser_impl  %{_javadir}/%{name}.jar 23
/usr/sbin/update-alternatives --auto jaxp_parser_impl

%post xml-apis
/usr/sbin/update-alternatives --install %{_javadir}/xml-commons-apis.jar         xml-commons-apis          %{_javadir}/%{name}-xml-apis.jar 1
/usr/sbin/update-alternatives --auto xml-commons-apis

%post xml-resolver
/usr/sbin/update-alternatives --install %{_javadir}/xml-commons-resolver.jar     xml-commons-resolver      %{_javadir}/%{name}-xml-resolver.jar 1
/usr/sbin/update-alternatives --auto xml-commons-resolver

%preun
{
  [ $1 = 0 ] || exit 0
  /usr/sbin/update-alternatives --remove jaxp_parser_impl        %{_javadir}/%{name}.jar
} >/dev/null 2>&1 || :

%preun xml-apis
{
  [ $1 = 0 ] || exit 0
  /usr/sbin/update-alternatives --remove xml-commons-apis        %{_javadir}/%{name}-xml-apis.jar
} >/dev/null 2>&1 || :

%preun xml-resolver
{
  [ $1 = 0 ] || exit 0
  /usr/sbin/update-alternatives --remove xml-commons-resolver    %{_javadir}/%{name}-xml-commons-resolver.jar
} >/dev/null 2>&1 || :

%files
%defattr(0644,root,root,0755)
%doc LICENSE README ISSUES STATUS TODO
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%ghost %{_javadir}/jaxp_parser_impl.jar

%files xml-apis
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}-xml-apis.jar
%{_javadir}/%{name}-xml-apis.jar
%ghost %{_javadir}/xml-commons-apis.jar

%files xml-resolver
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}-xml-resolver.jar
%{_javadir}/%{name}-xml-resolver.jar
%ghost %{_javadir}/xml-commons-resolver.jar

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}

%files scripts
%defattr(0755,root,root,0755)
%{_bindir}/*

%changelog
* Wed Sep 13 2017 pmonrealgonzalez@suse.com
- Fixed bug with applying a pattern restriction on long strings
  while trying to validate an XML file against a schema
  * Updated RegularExpression.java to the one in version 2.10
  * [bsc#1047536, bsc#879138]
- Added patch xerces-regularexpression-backport.patch
* Tue Apr 19 2016 pgajdos@suse.com
- Security update:
  * Possible-DoS [bsc#1047536, bsc#814241]
    + Added xerces-j2-arrays-doubling.patch
    + Added xerces-j2-scan-pseudo-attribute.patch
* Wed Jun 11 2014 tchvatal@suse.com
- Drop unused patches:
  * xerces-build.patch
  * xerces-j2-gcj-switch-constants-bug.patch
* Mon Sep  9 2013 tchvatal@suse.com
- Move from jpackage-utils to javapackage-tools
* Fri Aug 23 2013 mvyskocil@suse.com
- drop javadoc packages
- drop antlr-bootstrap from BR as javadoc is not built
* Fri Jan 11 2013 mvyskocil@suse.com
- removed the -boostrap package
* Fri Sep 16 2011 andrea.turrini@gmail.com
- fixed typos in xerces-j2.spec
* Mon Mar 14 2011 mvyskocil@suse.cz
- build ignore openjdk
* Tue Sep 21 2010 mvyskocil@suse.cz
- use antlr-bootstrap for javadoc build
* Mon Sep 13 2010 mvyskocil@suse.cz
- remove unecessary xerces-j2-build.patch
* Thu Sep  2 2010 mvyskocil@suse.cz
- ignore antlr(-java) to reduce build cycles
* Mon Aug 17 2009 mvyskocil@suse.cz
- fixed bnc#530717: VUL-0: xerces-j2: XML parsing vulnerability
- Removed non used patch xerces-build.patch
- Fixed some rpmlint warnings and errors
- Removed javadoc postinstall scripts
- Removed %%%%release from subpackages requires
* Wed Nov 12 2008 mvyskocil@suse.cz
- use gcj for build as this version is not compatible with INM Java6
- added a jpackage-utils to BuildRequires
* Fri Feb 29 2008 coolo@suse.de
- adding prereq for xml-apis and xml-resolver
* Wed Jan 23 2008 prusnak@suse.cz
- removed comma between symbols in PreReq
* Wed May  2 2007 dbornkessel@suse.de
- added unzip to BuildRequires
* Tue Jan 23 2007 dbornkessel@suse.de
- added dummy methods for not yet supported new dom methods
* Tue Jan 16 2007 dbornkessel@suse.de
- created sub-packages xml-apis and xml-resolver to avoid Bug #232127
* Wed Nov 15 2006 dbornkessel@suse.de
- Changed
    PreReq: /usr/sbin/update-alternatives
  to
    PreReq: update-alternatives
* Fri Sep 22 2006 dbornkessel@suse.de
- update to 2.8.1
- added source="1.4" target="1.4" to [x]javac & javadoc ant tasks
* Mon Jan 30 2006 dbornkessel@suse.de
- changed update alternatives prios
- corrected update-alternatives name for 'xml-commons-resolver'
* Fri Jan 27 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Jan 24 2006 dbornkessel@suse.de
- added missing jar file (xml-apis & resolver)
- added xml-apis and resolver to alternative system, so they can be
  interchanged with xml-commons-apis and commons-resolver
* Wed Jan 18 2006 dbornkessel@suse.de
- Update to version 2.7.1
* Wed Sep 28 2005 dmueller@suse.de
- add norootforbuild
* Thu Sep 16 2004 skh@suse.de
- Fix prerequires
* Thu Sep  2 2004 skh@suse.de
- Initial package created with version 2.6.2 (JPackage 1.5)
